org.apache.commons.logging

## Class LogFactory

- java.lang.Object
- - org.apache.commons.logging.LogFactory

- Direct Known Subclasses:
    SLF4JLogFactory

      public abstract class LogFactory
      extends Object

  Factory for creating `Log` instances, which always delegates to an instance of `SLF4JLogFactory`.

  Author:
    Craig R. McClanahan, Costin Manolache, Richard A. Sitze, Ceki Gülcü

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `DIAGNOSTICS_DEST_PROPERTY` The name (`org.apache.commons.logging.diagnostics.dest`) of the property used to enable internal commons-logging diagnostic output, in order to get information on what logging implementations are being discovered, what classloaders they are loaded through, etc.
    `protected static Hashtable` | `factories` The previously constructed `LogFactory` instances, keyed by the `ClassLoader` with which it was created.
    `static String` | `FACTORY_DEFAULT` The fully qualified class name of the fallback `LogFactory` implementation class to use, if no other can be found.
    `static String` | `FACTORY_PROPERTIES` The name of the properties file to search for.
    `static String` | `FACTORY_PROPERTY` The name of the property used to identify the LogFactory implementation class name.
    `static String` | `HASHTABLE_IMPLEMENTATION_PROPERTY` Setting this system property value allows the `Hashtable` used to store classloaders to be substituted by an alternative implementation.
    `protected static LogFactory` | `nullClassLoaderFactory` This property is not used but preserved here for compatibility.
    `static String` | `PRIORITY_KEY` The name (`priority`) of the key in the config file used to specify the priority of that particular config file.
    `protected static String` | `SERVICE_ID` JDK1.3+ 'Service Provider' specification.
    `static String` | `TCCL_KEY` The name (`use_tccl`) of the key in the config file used to specify whether logging classes should be loaded via the thread context class loader (TCCL), or not.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `LogFactory()` Protected constructor that is not available for public use.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static Object` | `createFactory(String factoryClass, ClassLoader classLoader)` This method exists to ensure signature compatibility.
    `protected static ClassLoader` | `directGetContextClassLoader()` This method exists to ensure signature compatibility.
    `abstract Object` | `getAttribute(String name)` Return the configuration attribute with the specified name (if any), or `null` if there is no such attribute.
    `abstract String[]` | `getAttributeNames()` Return an array containing the names of all currently defined configuration attributes.
    `protected static ClassLoader` | `getClassLoader(Class clazz)` This method exists to ensure signature compatibility.
    `protected static ClassLoader` | `getContextClassLoader()` This method exists to ensure signature compatibility.
    `static LogFactory` | `getFactory()` Construct (if necessary) and return a `LogFactory` instance, using the following ordered lookup procedure to determine the name of the implementation class to be loaded.
    `abstract Log` | `getInstance(Class clazz)` Convenience method to derive a name from the specified class and call `getInstance(String)` with it.
    `abstract Log` | `getInstance(String name)` Construct (if necessary) and return a `Log` instance, using the factory's current set of configuration attributes.
    `static Log` | `getLog(Class clazz)` Convenience method to return a named logger, without the application having to care about factories.
    `static Log` | `getLog(String name)` Convenience method to return a named logger, without the application having to care about factories.
    `protected static boolean` | `isDiagnosticsEnabled()` This method exists to ensure signature compatibility.
    `protected static void` | `logRawDiagnostic(String msg)` This method exists to ensure signature compatibility.
    `protected static LogFactory` | `newFactory(String factoryClass, ClassLoader classLoader)` This method exists to ensure signature compatibility.
    `protected static LogFactory` | `newFactory(String factoryClass, ClassLoader classLoader, ClassLoader contextClassLoader)` This method exists to ensure signature compatibility.
    `static String` | `objectId(Object o)` Returns a string that uniquely identifies the specified object, including its class.
    `abstract void` | `release()` Release any internal references to previously created `Log`instances returned by this factory.
    `static void` | `release(ClassLoader classLoader)` Release any internal references to previously created `LogFactory` instances that have been associated with the specified class loader (if any), after calling the instance method `release()` on each of them.
    `static void` | `releaseAll()` Release any internal references to previously created `LogFactory` instances, after calling the instance method `release()` on each of them.
    `abstract void` | `removeAttribute(String name)` Remove any configuration attribute associated with the specified name.
    `abstract void` | `setAttribute(String name, Object value)` Set the configuration attribute with the specified name.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### PRIORITY_KEY

          public static final String PRIORITY_KEY

      The name (`priority`) of the key in the config file used to specify the priority of that particular config file. The associated value is a floating-point number; higher values take priority over lower values.

      This property is not used but preserved here for compatibility.

      See Also:
        Constant Field Values

    - #### TCCL_KEY

          public static final String TCCL_KEY

      The name (`use_tccl`) of the key in the config file used to specify whether logging classes should be loaded via the thread context class loader (TCCL), or not. By default, the TCCL is used.

      This property is not used but preserved here for compatibility.

      See Also:
        Constant Field Values

    - #### FACTORY_PROPERTY

          public static final String FACTORY_PROPERTY

      The name of the property used to identify the LogFactory implementation class name.

      This property is not used but preserved here for compatibility.

      See Also:
        Constant Field Values

    - #### FACTORY_DEFAULT

          public static final String FACTORY_DEFAULT

      The fully qualified class name of the fallback `LogFactory` implementation class to use, if no other can be found.

      This property is not used but preserved here for compatibility.

      See Also:
        Constant Field Values

    - #### FACTORY_PROPERTIES

          public static final String FACTORY_PROPERTIES

      The name of the properties file to search for.

      This property is not used but preserved here for compatibility.

      See Also:
        Constant Field Values

    - #### SERVICE_ID

          protected static final String SERVICE_ID

      JDK1.3+ 'Service Provider' specification.

      This property is not used but preserved here for compatibility.

      See Also:
        Constant Field Values

    - #### DIAGNOSTICS_DEST_PROPERTY

          public static final String DIAGNOSTICS_DEST_PROPERTY

      The name (`org.apache.commons.logging.diagnostics.dest`) of the property used to enable internal commons-logging diagnostic output, in order to get information on what logging implementations are being discovered, what classloaders they are loaded through, etc.

      This property is not used but preserved here for compatibility.

      See Also:
        Constant Field Values

    - #### HASHTABLE_IMPLEMENTATION_PROPERTY

          public static final String HASHTABLE_IMPLEMENTATION_PROPERTY

      Setting this system property value allows the `Hashtable` used to store classloaders to be substituted by an alternative implementation.

      This property is not used but preserved here for compatibility.

      See Also:
        Constant Field Values

    - #### factories

          protected static Hashtable factories

      The previously constructed `LogFactory` instances, keyed by the `ClassLoader` with which it was created.

      This property is not used but preserved here for compatibility.

    - #### nullClassLoaderFactory

          protected static LogFactory nullClassLoaderFactory

      This property is not used but preserved here for compatibility.

  - ### Constructor Detail

    - #### LogFactory

          protected LogFactory()

      Protected constructor that is not available for public use.

  - ### Method Detail

    - #### getAttribute

          public abstract Object getAttribute(String name)

      Return the configuration attribute with the specified name (if any), or `null` if there is no such attribute.
      Parameters:
        `name` - Name of the attribute to return
      Returns:
        configuration attribute

    - #### getAttributeNames

          public abstract String[] getAttributeNames()

      Return an array containing the names of all currently defined configuration attributes. If there are no such attributes, a zero length array is returned.
      Returns:
        names of all currently defined configuration attributes

    - #### getInstance

          public abstract Log getInstance(Class clazz)
                                   throws LogConfigurationException

      Convenience method to derive a name from the specified class and call `getInstance(String)` with it.
      Parameters:
        `clazz` - Class for which a suitable Log name will be derived
      Throws:
        `LogConfigurationException` - if a suitable `Log` instance cannot be returned

    - #### getInstance

          public abstract Log getInstance(String name)
                                   throws LogConfigurationException

      Construct (if necessary) and return a `Log` instance, using the factory's current set of configuration attributes.

      NOTE - Depending upon the implementation of the `LogFactory` you are using, the `Log` instance you are returned may or may not be local to the current application, and may or may not be returned again on a subsequent call with the same name argument.

      Parameters:
        `name` - Logical name of the `Log` instance to be returned (the meaning of this name is only known to the underlying logging implementation that is being wrapped)
      Throws:
        `LogConfigurationException` - if a suitable `Log` instance cannot be returned

    - #### release

          public abstract void release()

      Release any internal references to previously created `Log`instances returned by this factory. This is useful in environments like servlet containers, which implement application reloading by throwing away a ClassLoader. Dangling references to objects in that class loader would prevent garbage collection.

    - #### removeAttribute

          public abstract void removeAttribute(String name)

      Remove any configuration attribute associated with the specified name. If there is no such attribute, no action is taken.
      Parameters:
        `name` - Name of the attribute to remove

    - #### setAttribute

          public abstract void setAttribute(String name,
                          Object value)

      Set the configuration attribute with the specified name. Calling this with a `null` value is equivalent to calling `removeAttribute(name)`.
      Parameters:
        `name` - Name of the attribute to set
        `value` - Value of the attribute to set, or `null` to remove any setting for this attribute

    - #### getFactory

          public static LogFactory getFactory()
                                       throws LogConfigurationException

      Construct (if necessary) and return a `LogFactory` instance, using the following ordered lookup procedure to determine the name of the implementation class to be loaded.

      - The `org.apache.commons.logging.LogFactory` system property.
      - The JDK 1.3 Service Discovery mechanism
      - Use the properties file `commons-logging.properties` file, if found in the class path of this class. The configuration file is in standard `java.util.Properties` format and contains the fully qualified name of the implementation class with the key being the system property defined above.
      - Fall back to a default implementation class ( `org.apache.commons.logging.impl.SLF4FLogFactory`).

      NOTE- If the properties file method of identifying the `LogFactory` implementation class is utilized, all of the properties defined in this file will be set as configuration attributes on the corresponding `LogFactory` instance.

      Throws:
        `LogConfigurationException` - if the implementation class is not available or cannot be instantiated.

    - #### getLog

          public static Log getLog(Class clazz)
                            throws LogConfigurationException

      Convenience method to return a named logger, without the application having to care about factories.
      Parameters:
        `clazz` - Class from which a log name will be derived
      Throws:
        `LogConfigurationException` - if a suitable `Log` instance cannot be returned

    - #### getLog

          public static Log getLog(String name)
                            throws LogConfigurationException

      Convenience method to return a named logger, without the application having to care about factories.
      Parameters:
        `name` - Logical name of the `Log` instance to be returned (the meaning of this name is only known to the underlying logging implementation that is being wrapped)
      Throws:
        `LogConfigurationException` - if a suitable `Log` instance cannot be returned

    - #### release

          public static void release(ClassLoader classLoader)

      Release any internal references to previously created `LogFactory` instances that have been associated with the specified class loader (if any), after calling the instance method `release()` on each of them.
      Parameters:
        `classLoader` - ClassLoader for which to release the LogFactory

    - #### releaseAll

          public static void releaseAll()

      Release any internal references to previously created `LogFactory` instances, after calling the instance method `release()` on each of them. This is useful in environments like servlet containers, which implement application reloading by throwing away a ClassLoader. Dangling references to objects in that class loader would prevent garbage collection.

    - #### objectId

          public static String objectId(Object o)

      Returns a string that uniquely identifies the specified object, including its class.

      The returned string is of form "classname@hashcode", i.e. is the same as the return value of the Object.toString() method, but works even when the specified object's class has overridden the toString method.

      Parameters:
        `o` - may be null.
      Returns:
        a string of form classname@hashcode, or "null" if param o is null.
      Since:
        1.1

    - #### createFactory

          protected static Object createFactory(String factoryClass,
                             ClassLoader classLoader)

      This method exists to ensure signature compatibility.

    - #### directGetContextClassLoader

          protected static ClassLoader directGetContextClassLoader()

      This method exists to ensure signature compatibility.

    - #### getContextClassLoader

          protected static ClassLoader getContextClassLoader()
                                                      throws LogConfigurationException

      This method exists to ensure signature compatibility.
      Throws:
        `LogConfigurationException`

    - #### getClassLoader

          protected static ClassLoader getClassLoader(Class clazz)

      This method exists to ensure signature compatibility.

    - #### isDiagnosticsEnabled

          protected static boolean isDiagnosticsEnabled()

      This method exists to ensure signature compatibility.

    - #### logRawDiagnostic

          protected static void logRawDiagnostic(String msg)

      This method exists to ensure signature compatibility.

    - #### newFactory

          protected static LogFactory newFactory(String factoryClass,
                              ClassLoader classLoader,
                              ClassLoader contextClassLoader)

      This method exists to ensure signature compatibility.

    - #### newFactory

          protected static LogFactory newFactory(String factoryClass,
                              ClassLoader classLoader)

      This method exists to ensure signature compatibility.

Copyright © 2005–2017 QOS.ch. All rights reserved.